;##################################################################
; DLL_W
;##################################################################

STRINGS UNICODE

#Include "DLL_W.h"

DATA SECTION
	hInstance		DD		0

;##################################################################

CODE SECTION

DllEntryPoint	FRAME hInst, reason, reserved1

	mov eax,[reason]
	.DLLPROCESSATTACH
	cmp eax,DLL_PROCESS_ATTACH
	JNE >.DLLPROCESSDETACH
		mov eax,[hInst]
		mov [hInstance], eax
		JMP >.LOAD
	
	.DLLPROCESSDETACH
	cmp eax,DLL_PROCESS_DETACH
	JNE >.DLLTHREADATTACH
		JMP >.LOAD
	
	.DLLTHREADATTACH
	cmp eax,DLL_THREAD_ATTACH
	JNE >.DLLTHREADDETACH
		JMP >.LOAD
	
	.DLLTHREADDETACH
	cmp eax,DLL_THREAD_DETACH
	JNE >.NOLOAD
		JMP >.LOAD
	
	.NOLOAD
		; The reson was not understood
		; Rather than take a chance we will refuse to load
		xor eax, eax
		ret
	
	.LOAD
		xor eax, eax
		inc eax

	ret
ENDF

