;##################################################################
; CustomControlW
;##################################################################

STRINGS UNICODE

#include "CustomControlW.h"

IDD_DLG1	equ		1000

DATA SECTION
	hInstance	DD 		?
	icc	 		DQ		3FFF00000008h
	UDC_Class	DUS		"UDC_ControlClass",0

CODE SECTION

START:
	invoke GetModuleHandle, 0
	mov [hInstance],eax
	invoke InitCommonControlsEx,OFFSET icc
	call InitClass
	invoke DialogBoxParam,[hInstance],IDD_DLG1,0,ADDR DlgProc,0
	invoke ExitProcess,0

DlgProc FRAME hwnd,uMsg,wParam,lParam

	cmp D[uMsg],WM_INITDIALOG
	jne >.WM_COMMAND

		jmp >.EXIT

	.WM_COMMAND
	cmp D[uMsg],WM_COMMAND
	jne >.WM_CLOSE
		jmp >.EXIT

	.WM_CLOSE
	cmp D[uMsg],WM_CLOSE
	jne >.DEFPROC
		INVOKE EndDialog,[hwnd],0

	.DEFPROC
		mov eax,FALSE
		ret

	.EXIT

	mov eax, TRUE
	ret
ENDF

InitClass FRAME
	LOCAL cc_wcx			:WNDCLASSEX

	mov D[cc_wcx.cbSize],SIZEOF WNDCLASSEX
	mov D[cc_wcx.style], CS_HREDRAW + CS_VREDRAW
	mov eax,[hInstance]
	mov D[cc_wcx.hInstance],eax
	mov D[cc_wcx.lpszClassName],OFFSET UDC_Class
	mov D[cc_wcx.cbClsExtra],0
	mov D[cc_wcx.cbWndExtra],32
	mov D[cc_wcx.lpfnWndProc],OFFSET _CCProc
	mov D[cc_wcx.hIcon],NULL
	mov D[cc_wcx.hIconSm],NULL
	mov D[cc_wcx.hbrBackground],COLOR_WINDOW+1
	mov D[cc_wcx.lpszMenuName],NULL

	invoke LoadCursor,NULL,IDC_ARROW
	mov [cc_wcx.hCursor],eax

	invoke RegisterClassEx,ADDR cc_wcx

	ret

ENDF

_CCProc FRAME hwnd,uMsg,wParam,lParam

	cmp D[uMsg],WM_CREATE
	jne >.WM_DESTROY
		
		jmp >.EXIT

	.WM_DESTROY
	cmp D[uMsg],WM_DESTROY
	jne >.DEFPROC
		
		jmp >.EXIT

	.DEFPROC
		invoke DefWindowProc,[hwnd],[uMsg],[wParam],[lParam]
		ret

	.EXIT
	xor eax,eax
	RET
ENDF
